package com.gic.store.service.outer;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.store.dto.StoreFieldDTO;
import com.gic.store.service.StoreFieldApiService;
import com.gic.store.service.StoreFieldService;
import com.gic.store.utils.ErrorCode;
import com.gic.store.utils.StoreFieldValidParamUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author guojx
 * @date 2019/6/28 1:40 PM
 */
@Service("storeFieldApiService")
public class StoreFieldApiServiceImpl implements StoreFieldApiService{
    @Autowired
    private StoreFieldService storeFieldService;

    @Override
    public ServiceResponse<Integer> save(StoreFieldDTO storeFieldDTO) {
        ServiceResponse validParamResult = StoreFieldValidParamUtil.validStoreFieldDetail(storeFieldDTO.getStoreFieldType(), storeFieldDTO.getStoreFieldDetail());
        if (!validParamResult.isSuccess()) {
            return validParamResult;
        }
        if (StringUtils.isBlank(storeFieldDTO.getStoreFieldName())) {
            return ServiceResponse.failure(ErrorCode.ERR_5.getCode(), "属性名称参数值错误");
        }
        if (storeFieldDTO.getStoreFieldType() == null) {
            return ServiceResponse.failure(ErrorCode.ERR_5.getCode(), "字段类型参数值错误");
        }
        if (StringUtils.isBlank(storeFieldDTO.getStoreRegionId())) {
            return ServiceResponse.failure(ErrorCode.ERR_5.getCode(), "所属域参数值错误");
        }
        return ServiceResponse.success(storeFieldService.save(storeFieldDTO));
    }
}
